package jp.mosp.payroll.payment.vo;

import javax.servlet.http.HttpServletRequest;

import jp.mosp.payroll.base.PayrollVo;

/**
 * 給与計算開始画面に関する情報を扱う。
 */
public class StartCalcVo extends PayrollVo {
	
	private static final long serialVersionUID = 6398055375236133331L;
	
	// フィールド
	private int pltYear;
	private int pltMonth;
	
	// プルダウン
	private String[][] pitYear ;
	private String[][] pitMonth;
	
	// 画面モード
	private int mode;
	
	/**
	 * パラメータ名(給与計算開始年)。
	 */
	public static final String PRM_PLT_YEAR = "pltYear";
	
	/**
	 * パラメータ名(給与計算開始月)。
	 */
	public static final String PRM_PLT_MONTH = "pltMonth";
	
	/**
	 * {@link PayrollVo#PayrollVo()}を実行する。
	 */
	public StartCalcVo() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.payroll.base.PayrollVo#setSubTitle()
	 */
	@Override
	protected void setSubTitle() {
		super.setSubTitle();
		subTitle = getName("P_PAYROLL") + getName("C_START");
		addAryMenu("P1001", getName("P_PAYMENT") +
				getName("P_CALCULATE") + getName("C_MENU") + getName("C_TO"));
	}
	
	/**
	 * リクエストからパラメータを取得、設定する。
	 * @param request リクエスト
	 */
	public void setParams(HttpServletRequest request) {
		pltYear  = getIntParam(request.getParameter(PRM_PLT_YEAR ));
		pltMonth = getIntParam(request.getParameter(PRM_PLT_MONTH));
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.payroll.base.PayrollVo#getDirectJs(Class)
	 */
	@Override
	public String getDirectJs(Class<?> cls) throws IllegalAccessException {
		StringBuffer sb = new StringBuffer();
		sb.append(super.getDirectJs(cls));
		sb.append("var MODE = ");
		sb.append(mode);
		sb.append(";");
		return sb.toString();
	}
	
	/**
	 * 給与計算開始月を取得する。
	 * @return 給与計算開始月
	 */
	public int getPltMonth() {
		return pltMonth;
	}

	/**
	 * 給与計算開始月を設定する。
	 * @param pltMonth 設定する給与計算開始月
	 */
	public void setPltMonth(int pltMonth) {
		this.pltMonth = pltMonth;
	}

	/**
	 * 給与計算開始年を取得する。
	 * @return 給与計算開始年
	 */
	public int getPltYear() {
		return pltYear;
	}

	/**
	 * 給与計算開始年を設定する。
	 * @param pltYear 設定する給与計算開始年
	 */
	public void setPltYear(int pltYear) {
		this.pltYear = pltYear;
	}

	/**
	 * 月プルダウンアイテムを取得する。
	 * @return 月プルダウンアイテム
	 */
	public String[][] getPitMonth() {
		return getAryField(pitMonth);
	}

	/**
	 * 月プルダウンアイテムを設定する。
	 * @param pitMonth 設定する月プルダウンアイテム
	 */
	public void setPitMonth(String[][] pitMonth) {
		this.pitMonth = getAryField(pitMonth);
	}

	/**
	 * 年プルダウンアイテムを取得する。
	 * @return 年プルダウンアイテム
	 */
	public String[][] getPitYear() {
		return getAryField(pitYear);
	}

	/**
	 * 年プルダウンアイテムを設定する。
	 * @param pitYear 設定する年プルダウンアイテム
	 */
	public void setPitYear(String[][] pitYear) {
		this.pitYear = getAryField(pitYear);
	}

	/**
	 * 画面モードを設定する。<br><br>
	 * 0:通常、1：計算中、2：強制実行
	 * @param mode 設定する画面モード
	 */
	public void setMode(int mode) {
		this.mode = mode;
	}
	
}
